package io.github.lonamiwebs.overgram.tl;

import io.github.lonamiwebs.overgram.utils.BinaryReader;
import io.github.lonamiwebs.overgram.utils.BinaryWriter;

import java.util.ArrayList;
import java.util.List;

public class MessageContainer extends TLObject {
    public static final int CONSTRUCTOR_ID = 1945237724;

    final public List<TLMessage> messages = new ArrayList<>();

    @Override
    public void serialize(final BinaryWriter writer) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void deserialize(final BinaryReader reader) throws ClassNotFoundException {
        messages.clear();
        final int count = reader.readInt();
        for (int i = 0; i < count; ++i) {
            final long msgId = reader.readLong();
            final int seqNo = reader.readInt();
            final int length = reader.readInt();
            final int before = reader.tell();
            final TLObject object = reader.readTl();
            reader.set(before + length);
            messages.add(new TLMessage(msgId, seqNo, object));
        }
    }
}
